package com.dstsystems;

import java.lang.reflect.Constructor;
import java.net.MalformedURLException;
import java.net.URL;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.EntityTransaction;
import javax.persistence.Persistence;
import javax.xml.namespace.QName;
import javax.xml.ws.Service;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;

public class JPABaseTest
{
    private static final String TEST_PERSISTENCE_UNIT = "RICCDB";
    
    protected static EntityManagerFactory emf;
    protected static EntityManager entityManager;
    protected static EntityTransaction trans;
    
    @BeforeClass public static void beforeClass()
    {
        try
        {
            emf = Persistence.createEntityManagerFactory(TEST_PERSISTENCE_UNIT);     
            entityManager = emf.createEntityManager();
        }
        catch( Exception e)
        {
            e.printStackTrace();
        }
    }
    @Before public void before()
    {
        trans = entityManager.getTransaction();
    }
    @After public void after()
    {
    }
    
    @AfterClass public static void afterClass()
    {
        entityManager.close();
    }
    protected <T extends Service> T instantiateServiceStub( Class<T> serviceClass ) throws MalformedURLException
    {
        URL wsdlLocation = new URL("http://localhost:28080/SampleServiceEAR-SampleService/ProductSponsor?wsdl");
        QName qname = new QName( "http://services.dstsystems.com/", "ProductSponsorService" );
        Service service = null;
        try
        {
            Constructor<T> constructor = serviceClass.getConstructor( URL.class, QName.class );
            if( constructor == null )
            {
                service = serviceClass.newInstance();
            }
            else
            {
                service = constructor.newInstance( wsdlLocation, qname );
            }
        }
        catch( Exception e )
        {
            e.printStackTrace();
        }
        return serviceClass.cast( service );
     }
    
}

