
package com.dstsystems.services;

import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

/**
 * Utility class that creates an Entity Manager Factory for JUnit Tests to support the application
 * managed persistence.    
 */
public class JPAUtil
{
    private static EntityManagerFactory entityManagerFactory = null;

    /**
     * Gets and Entity Manager Factory based on the persistent unit defined in the persistence.xml
     * file.  An Entity Manager Factory will enable the client to create an EntityManager which 
     * then manages the transactions for the Java Persistence API (JPA).
     * @return an Entity Manager Factory.
     */
    public static synchronized EntityManagerFactory getEntityManagerFactory()
    {
        if ( entityManagerFactory == null )
        {
            entityManagerFactory = Persistence.createEntityManagerFactory( "RICCDB" );
        }
        return entityManagerFactory;
    }

}
